/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the MSSQLStorageRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MSSQLStorageRequest{}

// MSSQLStorageRequest struct for MSSQLStorageRequest
type MSSQLStorageRequest struct {
	Label   *string `json:"label,omitempty"`
	Type    *string `json:"type,omitempty"`
	OAuthId *int32  `json:"o_auth_id,omitempty"`
}

// NewMSSQLStorageRequest instantiates a new MSSQLStorageRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMSSQLStorageRequest() *MSSQLStorageRequest {
	this := MSSQLStorageRequest{}
	return &this
}

// NewMSSQLStorageRequestWithDefaults instantiates a new MSSQLStorageRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMSSQLStorageRequestWithDefaults() *MSSQLStorageRequest {
	this := MSSQLStorageRequest{}
	return &this
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *MSSQLStorageRequest) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MSSQLStorageRequest) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *MSSQLStorageRequest) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *MSSQLStorageRequest) SetLabel(v string) {
	o.Label = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *MSSQLStorageRequest) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MSSQLStorageRequest) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *MSSQLStorageRequest) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *MSSQLStorageRequest) SetType(v string) {
	o.Type = &v
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *MSSQLStorageRequest) GetOAuthId() int32 {
	if o == nil || IsNil(o.OAuthId) {
		var ret int32
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MSSQLStorageRequest) GetOAuthIdOk() (*int32, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *MSSQLStorageRequest) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given int32 and assigns it to the OAuthId field.
func (o *MSSQLStorageRequest) SetOAuthId(v int32) {
	o.OAuthId = &v
}

func (o MSSQLStorageRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MSSQLStorageRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.OAuthId) {
		toSerialize["o_auth_id"] = o.OAuthId
	}
	return toSerialize, nil
}

type NullableMSSQLStorageRequest struct {
	value *MSSQLStorageRequest
	isSet bool
}

func (v NullableMSSQLStorageRequest) Get() *MSSQLStorageRequest {
	return v.value
}

func (v *NullableMSSQLStorageRequest) Set(val *MSSQLStorageRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableMSSQLStorageRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableMSSQLStorageRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMSSQLStorageRequest(val *MSSQLStorageRequest) *NullableMSSQLStorageRequest {
	return &NullableMSSQLStorageRequest{value: val, isSet: true}
}

func (v NullableMSSQLStorageRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMSSQLStorageRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
